Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4671)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces for RTM 4.1
+! Author: J. Resler (Institute of Computer Science, Prague)
+!
+! 4669 2020-09-09 13:43:47Z pavelkrc
 ! Fix calculation of force_radiation_call
 ! 
@@ -449,32 +453,36 @@
                                    zs_layer = 9999999.9_wp             !< soil layer depths (edge)
 
-    TYPE(surf_type_lsm), POINTER ::  t_soil_h,    & !< Soil temperature (K), horizontal surface elements
-                                     t_soil_h_p,  & !< Prog. soil temperature (K), horizontal surface elements
-                                     m_soil_h,    & !< Soil moisture (m3/m3), horizontal surface elements
-                                     m_soil_h_p     !< Prog. soil moisture (m3/m3), horizontal surface elements
-
-    TYPE(surf_type_lsm), TARGET  ::  t_soil_h_1,  & !<
-                                     t_soil_h_2,  & !<
-                                     m_soil_h_1,  & !<
-                                     m_soil_h_2     !<
-
-    TYPE(surf_type_lsm), DIMENSION(:), POINTER :: &
-                                     t_soil_v,    & !< Soil temperature (K), vertical surface elements
-                                     t_soil_v_p,  & !< Prog. soil temperature (K), vertical surface elements
-                                     m_soil_v,    & !< Soil moisture (m3/m3), vertical surface elements
-                                     m_soil_v_p     !< Prog. soil moisture (m3/m3), vertical surface elements
-
-    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::&
-                                     t_soil_v_1,  & !<
-                                     t_soil_v_2,  & !<
-                                     m_soil_v_1,  & !<
-                                     m_soil_v_2     !<
-
-    TYPE(surf_type_lsm), POINTER  ::  t_surface_h,    & !< surface temperature (K), horizontal surface elements
+    TYPE(surf_type_lsm), DIMENSION(:), POINTER ::     &
+                                     t_soil_h,        & !< Soil temperature (K), horizontal surface elements
+                                     t_soil_h_p,      & !< Prog. soil temperature (K), horizontal surface elements
+                                     m_soil_h,        & !< Soil moisture (m3/m3), horizontal surface elements
+                                     m_soil_h_p         !< Prog. soil moisture (m3/m3), horizontal surface elements
+
+    TYPE(surf_type_lsm), DIMENSION(0:1), TARGET ::    &
+                                     t_soil_h_1,      & !<
+                                     t_soil_h_2,      & !<
+                                     m_soil_h_1,      & !<
+                                     m_soil_h_2         !<
+
+    TYPE(surf_type_lsm), DIMENSION(:), POINTER ::     &
+                                     t_soil_v,        & !< Soil temperature (K), vertical surface elements
+                                     t_soil_v_p,      & !< Prog. soil temperature (K), vertical surface elements
+                                     m_soil_v,        & !< Soil moisture (m3/m3), vertical surface elements
+                                     m_soil_v_p         !< Prog. soil moisture (m3/m3), vertical surface elements
+
+    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::    &
+                                     t_soil_v_1,      & !<
+                                     t_soil_v_2,      & !<
+                                     m_soil_v_1,      & !<
+                                     m_soil_v_2        !<
+
+    TYPE(surf_type_lsm), DIMENSION(:), POINTER ::&
+                                      t_surface_h,    & !< surface temperature (K), horizontal surface elements
                                       t_surface_h_p,  & !< progn. surface temperature (K), horizontal surface elements
                                       m_liq_h,        & !< liquid water reservoir (m), horizontal surface elements
                                       m_liq_h_p         !< progn. liquid water reservoir (m), horizontal surface elements
 
-    TYPE(surf_type_lsm), TARGET   ::  t_surface_h_1,  & !<
+    TYPE(surf_type_lsm), DIMENSION(0:1), TARGET ::    &
+                                      t_surface_h_1,  & !<
                                       t_surface_h_2,  & !<
                                       m_liq_h_1,      & !<
@@ -498,8 +506,8 @@
                                                         m_soil_av    !< Average of m_soil
 
-    TYPE(surf_type_lsm), TARGET ::  tm_liq_h_m      !< liquid water reservoir tendency (m), horizontal surface elements
-    TYPE(surf_type_lsm), TARGET ::  tt_surface_h_m  !< surface temperature tendency (K), horizontal surface elements
-    TYPE(surf_type_lsm), TARGET ::  tt_soil_h_m     !< t_soil storage array, horizontal surface elements
-    TYPE(surf_type_lsm), TARGET ::  tm_soil_h_m     !< m_soil storage array, horizontal surface elements
+    TYPE(surf_type_lsm), DIMENSION(0:1), TARGET ::  tm_liq_h_m      !< liquid water reservoir tendency (m), horizontal surface elements
+    TYPE(surf_type_lsm), DIMENSION(0:1), TARGET ::  tt_surface_h_m  !< surface temperature tendency (K), horizontal surface elements
+    TYPE(surf_type_lsm), DIMENSION(0:1), TARGET ::  tt_soil_h_m     !< t_soil storage array, horizontal surface elements
+    TYPE(surf_type_lsm), DIMENSION(0:1), TARGET ::  tm_soil_h_m     !< m_soil storage array, horizontal surface elements
 
     TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tm_liq_v_m      !< liquid water reservoir tendency (m), vertical surface elements
@@ -871,10 +879,12 @@
     INTEGER(iwp) :: m      !< running index surface elements
 
-    koff = surf_lsm_h%koff
-    DO  m = 1, surf_lsm_h%ns
-       i = surf_lsm_h%i(m)
-       j = surf_lsm_h%j(m)
-       k = surf_lsm_h%k(m)
-       pt(k+koff,j,i) = pt(k,j,i)
+    DO l = 0, 1
+       koff = surf_lsm_h(l)%koff
+       DO  m = 1, surf_lsm_h(l)%ns
+          i = surf_lsm_h(l)%i(m)
+          j = surf_lsm_h(l)%j(m)
+          k = surf_lsm_h(l)%k(m)
+          pt(k+koff,j,i) = pt(k,j,i)
+       ENDDO
     ENDDO
 
@@ -892,13 +902,14 @@
 !-- In case of humidity, set boundary conditions also for q and vpt.
     IF ( humidity )  THEN
-       koff = surf_lsm_h%koff
-       DO  m = 1, surf_lsm_h%ns
-          i = surf_lsm_h%i(m)
-          j = surf_lsm_h%j(m)
-          k = surf_lsm_h%k(m)
-          q(k+koff,j,i)   = q(k,j,i)
-          vpt(k+koff,j,i) = vpt(k,j,i)
+       DO  l = 0, 1
+          koff = surf_lsm_h(l)%koff
+          DO  m = 1, surf_lsm_h(l)%ns
+             i = surf_lsm_h(l)%i(m)
+             j = surf_lsm_h(l)%j(m)
+             k = surf_lsm_h(l)%k(m)
+             q(k+koff,j,i)   = q(k,j,i)
+             vpt(k+koff,j,i) = vpt(k,j,i)
+          ENDDO
        ENDDO
-
        DO  l = 0, 3
           ioff = surf_lsm_v(l)%ioff
@@ -1597,7 +1608,37 @@
 ! Description:
 ! ------------
+!> Calls energy balance solver and soil energy model the surfaces in all directions.
+!------------------------------------------------------------------------------!
+ SUBROUTINE lsm_energy_balance ( during_spinup )
+
+    USE control_parameters,                                                                        &
+        ONLY:  calc_soil_moisture_during_spinup
+
+    LOGICAL      ::  during_spinup  !< flag indicating soil/wall spinup phase
+    LOGICAL      ::  calc_sm
+    INTEGER(iwp) ::  l              !< loop index for surface types
+
+    calc_sm = .NOT. during_spinup .OR. calc_soil_moisture_during_spinup
+!
+!-- Call for horizontal surfaces
+    DO l = 0, 1
+       CALL lsm_surface_energy_balance( .TRUE., l )
+       CALL lsm_soil_model( .TRUE., l, calc_sm )
+    ENDDO
+!
+!--   Call for vertical surfaces
+    DO l = 0, 3
+       CALL lsm_surface_energy_balance( .FALSE., l )
+       CALL lsm_soil_model( .FALSE., l, calc_sm )
+    ENDDO
+
+END SUBROUTINE lsm_energy_balance
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
 !> Solver for the energy balance at the surface.
 !------------------------------------------------------------------------------!
- SUBROUTINE lsm_energy_balance( horizontal, l )
+ SUBROUTINE lsm_surface_energy_balance( horizontal, l )
 
     USE pegrid
@@ -1617,4 +1658,5 @@
 
     LOGICAL      ::  horizontal !< Flag indicating horizontal or vertical surfaces
+    LOGICAL      ::  upward     !< Flag indicating upward horizontal surfaces
 
     REAL(wp) :: c_surface_tmp,  & !< temporary variable for storing the volumetric heat capacity of the surface
@@ -1654,22 +1696,22 @@
 
     IF ( debug_output_timestep )  THEN
-       WRITE( debug_string, * ) 'lsm_energy_balance', horizontal, l
+       WRITE( debug_string, * ) 'lsm_surface_energy_balance', horizontal, l
        CALL debug_message( debug_string, 'start' )
     ENDIF
 
+    upward = .FALSE.
     IF ( horizontal )  THEN
-       surf              => surf_lsm_h
-
-       surf_t_surface    => t_surface_h
-       surf_t_surface_p  => t_surface_h_p
-       surf_tt_surface_m => tt_surface_h_m
-       surf_m_liq        => m_liq_h
-       surf_m_liq_p      => m_liq_h_p
-       surf_tm_liq_m     => tm_liq_h_m
-       surf_m_soil       => m_soil_h
-       surf_t_soil       => t_soil_h
+       surf              => surf_lsm_h(l)
+       surf_t_surface    => t_surface_h(l)
+       surf_t_surface_p  => t_surface_h_p(l)
+       surf_tt_surface_m => tt_surface_h_m(l)
+       surf_m_liq        => m_liq_h(l)
+       surf_m_liq_p      => m_liq_h_p(l)
+       surf_tm_liq_m     => tm_liq_h_m(l)
+       surf_m_soil       => m_soil_h(l)
+       surf_t_soil       => t_soil_h(l)
+       IF ( l == 0 ) upward = .TRUE.
     ELSE
        surf              => surf_lsm_v(l)
-
        surf_t_surface    => t_surface_v(l)
        surf_t_surface_p  => t_surface_v_p(l)
@@ -1777,5 +1819,5 @@
 !        ENDIF
 !
-!--     Calculation of r_a for vertical surfaces
+!--     Calculation of r_a for vertical and horizontal downward surfaces
 !--
 !--     heat transfer coefficient for forced convection along vertical walls
@@ -1806,5 +1848,5 @@
 !--    holes, the resistance can become negative. For this reason, limit r_a
 !--    to positive values.
-       IF ( horizontal  .OR.  .NOT. aero_resist_kray )  THEN
+       IF ( upward .OR.  .NOT. aero_resist_kray )  THEN
           surf%r_a(m) = ABS( ( surf%pt1(m) - surf%pt_surface(m) ) /                               &
                              ( surf%ts(m) * surf%us(m) + 1.0E-20_wp ) )
@@ -2055,5 +2097,5 @@
 !
 ! update the 3d field of rad_lw_out array to have consistent output
-       IF ( horizontal ) THEN
+       IF ( upward )  THEN
           IF ( radiation_scheme == 'rrtmg' ) THEN
              rad_lw_out(k+k_off,j+j_off,i+i_off) = surf%rad_lw_out(m)
@@ -2217,8 +2259,8 @@
 !
 !-- Calculate new roughness lengths (for water surfaces only)
-    IF ( horizontal  .AND.  .NOT. constant_roughness )  CALL calc_z0_water_surface
+    IF ( upward .AND.  .NOT. constant_roughness )  CALL calc_z0_water_surface
 
     IF ( debug_output_timestep )  THEN
-       WRITE( debug_string, * ) 'lsm_energy_balance', horizontal, l
+       WRITE( debug_string, * ) 'lsm_surface_energy_balance', horizontal, l
        CALL debug_message( debug_string, 'end' )
     ENDIF
@@ -2282,5 +2324,5 @@
     END SUBROUTINE calc_q_surface
 
- END SUBROUTINE lsm_energy_balance
+ END SUBROUTINE lsm_surface_energy_balance
 
 
@@ -2443,20 +2485,22 @@
 !--    Set initial values for prognostic quantities
 !--    Horizontal surfaces
-       tt_surface_h_m%var_1d = 0.0_wp
-       tt_soil_h_m%var_2d    = 0.0_wp
-       tm_soil_h_m%var_2d    = 0.0_wp
-       tm_liq_h_m%var_1d     = 0.0_wp
-       surf_lsm_h%c_liq      = 0.0_wp
-
-       surf_lsm_h%ghf = 0.0_wp
-
-       surf_lsm_h%qsws_liq  = 0.0_wp
-       surf_lsm_h%qsws_soil = 0.0_wp
-       surf_lsm_h%qsws_veg  = 0.0_wp
-
-       surf_lsm_h%r_a        = 50.0_wp
-       surf_lsm_h%r_s        = 50.0_wp
-       surf_lsm_h%r_canopy   = 0.0_wp
-       surf_lsm_h%r_soil     = 0.0_wp
+       DO  l = 0, 1
+          tt_surface_h_m(l)%var_1d = 0.0_wp
+          tt_soil_h_m(l)%var_2d    = 0.0_wp
+          tm_soil_h_m(l)%var_2d    = 0.0_wp
+          tm_liq_h_m(l)%var_1d     = 0.0_wp
+          surf_lsm_h(l)%c_liq      = 0.0_wp
+
+          surf_lsm_h(l)%ghf = 0.0_wp
+
+          surf_lsm_h(l)%qsws_liq  = 0.0_wp
+          surf_lsm_h(l)%qsws_soil = 0.0_wp
+          surf_lsm_h(l)%qsws_veg  = 0.0_wp
+
+          surf_lsm_h(l)%r_a        = 50.0_wp
+          surf_lsm_h(l)%r_s        = 50.0_wp
+          surf_lsm_h(l)%r_canopy   = 0.0_wp
+          surf_lsm_h(l)%r_soil     = 0.0_wp
+       ENDDO
 !
 !--    Do the same for vertical surfaces
@@ -2483,8 +2527,9 @@
 !--    Set initial values for prognostic soil quantities
        IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
-          t_soil_h%var_2d = 0.0_wp
-          m_soil_h%var_2d = 0.0_wp
-          m_liq_h%var_1d  = 0.0_wp
-
+          DO  l = 0, 1
+             t_soil_h(l)%var_2d = 0.0_wp
+             m_soil_h(l)%var_2d = 0.0_wp
+             m_liq_h(l)%var_1d  = 0.0_wp
+          ENDDO
           DO  l = 0, 3
              t_soil_v(l)%var_2d = 0.0_wp
@@ -2496,27 +2541,29 @@
 !--    Allocate 3D soil model arrays
 !--    First, for horizontal surfaces
-       ALLOCATE ( surf_lsm_h%alpha_vg(nzb_soil:nzt_soil,1:surf_lsm_h%ns)    )
-       ALLOCATE ( surf_lsm_h%gamma_w_sat(nzb_soil:nzt_soil,1:surf_lsm_h%ns) )
-       ALLOCATE ( surf_lsm_h%lambda_h(nzb_soil:nzt_soil,1:surf_lsm_h%ns)    )
-       ALLOCATE ( surf_lsm_h%lambda_h_def(nzb_soil:nzt_soil,1:surf_lsm_h%ns))
-       ALLOCATE ( surf_lsm_h%l_vg(nzb_soil:nzt_soil,1:surf_lsm_h%ns)        )
-       ALLOCATE ( surf_lsm_h%m_fc(nzb_soil:nzt_soil,1:surf_lsm_h%ns)        )
-       ALLOCATE ( surf_lsm_h%m_res(nzb_soil:nzt_soil,1:surf_lsm_h%ns)       )
-       ALLOCATE ( surf_lsm_h%m_sat(nzb_soil:nzt_soil,1:surf_lsm_h%ns)       )
-       ALLOCATE ( surf_lsm_h%m_wilt(nzb_soil:nzt_soil,1:surf_lsm_h%ns)      )
-       ALLOCATE ( surf_lsm_h%n_vg(nzb_soil:nzt_soil,1:surf_lsm_h%ns)        )
-       ALLOCATE ( surf_lsm_h%rho_c_total(nzb_soil:nzt_soil,1:surf_lsm_h%ns) )
-       ALLOCATE ( surf_lsm_h%rho_c_total_def(nzb_soil:nzt_soil,1:surf_lsm_h%ns) )
-       ALLOCATE ( surf_lsm_h%root_fr(nzb_soil:nzt_soil,1:surf_lsm_h%ns)     )
-
-       surf_lsm_h%lambda_h     = 0.0_wp
-!
-!--    If required, allocate humidity-related variables for the soil model
-       IF ( humidity )  THEN
-          ALLOCATE ( surf_lsm_h%lambda_w(nzb_soil:nzt_soil,1:surf_lsm_h%ns) )
-          ALLOCATE ( surf_lsm_h%gamma_w(nzb_soil:nzt_soil,1:surf_lsm_h%ns)  )
-
-          surf_lsm_h%lambda_w = 0.0_wp
-       ENDIF
+       DO  l = 0, 1
+          ALLOCATE ( surf_lsm_h(l)%alpha_vg(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns)    )
+          ALLOCATE ( surf_lsm_h(l)%gamma_w_sat(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns) )
+          ALLOCATE ( surf_lsm_h(l)%lambda_h(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns)    )
+          ALLOCATE ( surf_lsm_h(l)%lambda_h_def(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns))
+          ALLOCATE ( surf_lsm_h(l)%l_vg(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns)        )
+          ALLOCATE ( surf_lsm_h(l)%m_fc(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns)        )
+          ALLOCATE ( surf_lsm_h(l)%m_res(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns)       )
+          ALLOCATE ( surf_lsm_h(l)%m_sat(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns)       )
+          ALLOCATE ( surf_lsm_h(l)%m_wilt(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns)      )
+          ALLOCATE ( surf_lsm_h(l)%n_vg(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns)        )
+          ALLOCATE ( surf_lsm_h(l)%rho_c_total(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns) )
+          ALLOCATE ( surf_lsm_h(l)%rho_c_total_def(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns) )
+          ALLOCATE ( surf_lsm_h(l)%root_fr(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns)     )
+
+          surf_lsm_h(l)%lambda_h     = 0.0_wp
+!
+!--       If required, allocate humidity-related variables for the soil model
+          IF ( humidity )  THEN
+             ALLOCATE ( surf_lsm_h(l)%lambda_w(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns) )
+             ALLOCATE ( surf_lsm_h(l)%gamma_w(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns)  )
+
+             surf_lsm_h(l)%lambda_w = 0.0_wp
+          ENDIF
+       ENDDO
 !
 !--    For vertical surfaces
@@ -2551,16 +2598,18 @@
 !--    fraction.
 !--    Set default values at each surface element.
-       ALLOCATE ( surf_lsm_h%albedo_type(1:surf_lsm_h%ns,0:2) )
-       ALLOCATE ( surf_lsm_h%emissivity(1:surf_lsm_h%ns,0:2) )
-!
-!--    Initialize albedo type according to its default type, in order to set values
-!--    independent on default albedo_type in radiation model.
-       surf_lsm_h%albedo_type(:,ind_veg_wall)  =                               &
-                             INT( vegetation_pars(ind_v_at,vegetation_type) )
-       surf_lsm_h%albedo_type(:,ind_wat_win)   =                               &
-                             INT( water_pars(ind_w_at,water_type)           )
-       surf_lsm_h%albedo_type(:,ind_pav_green) =                               &
-                             INT( pavement_pars(ind_p_at,pavement_type)     )
-       surf_lsm_h%emissivity  = emissivity
+       DO  l = 0, 1
+          ALLOCATE ( surf_lsm_h(l)%albedo_type(1:surf_lsm_h(l)%ns,0:2) )
+          ALLOCATE ( surf_lsm_h(l)%emissivity(1:surf_lsm_h(l)%ns,0:2) )
+!
+!--       Initialize albedo type according to its default type, in order to set values
+!--       independent on default albedo_type in radiation model.
+          surf_lsm_h(l)%albedo_type(:,ind_veg_wall)  =                               &
+                                INT( vegetation_pars(ind_v_at,vegetation_type) )
+          surf_lsm_h(l)%albedo_type(:,ind_wat_win)   =                               &
+                                INT( water_pars(ind_w_at,water_type)           )
+          surf_lsm_h(l)%albedo_type(:,ind_pav_green) =                               &
+                                INT( pavement_pars(ind_p_at,pavement_type)     )
+          surf_lsm_h(l)%emissivity  = emissivity
+       ENDDO
        DO  l = 0, 3
           ALLOCATE ( surf_lsm_v(l)%albedo_type(1:surf_lsm_v(l)%ns,0:2) )
@@ -2580,6 +2629,8 @@
 !--    Allocate arrays for relative surface fraction.
 !--    0 - vegetation fraction, 2 - water fraction, 1 - pavement fraction
-       ALLOCATE( surf_lsm_h%frac(1:surf_lsm_h%ns,0:2) )
-       surf_lsm_h%frac = 0.0_wp
+       DO  l = 0, 1
+          ALLOCATE( surf_lsm_h(l)%frac(1:surf_lsm_h(l)%ns,0:2) )
+          surf_lsm_h(l)%frac = 0.0_wp
+       ENDDO
        DO  l = 0, 3
           ALLOCATE( surf_lsm_v(l)%frac(1:surf_lsm_v(l)%ns,0:2) )
@@ -2595,20 +2646,21 @@
 !--    Allocate arrays for the respective types and their names on the surface
 !--    elements. This will be required to treat deposition of chemical species.
-       ALLOCATE( surf_lsm_h%pavement_type(1:surf_lsm_h%ns)   )
-       ALLOCATE( surf_lsm_h%vegetation_type(1:surf_lsm_h%ns) )
-       ALLOCATE( surf_lsm_h%water_type(1:surf_lsm_h%ns)      )
-
-       surf_lsm_h%pavement_type   = 0
-       surf_lsm_h%vegetation_type = 0
-       surf_lsm_h%water_type      = 0
-
-       ALLOCATE( surf_lsm_h%pavement_type_name(1:surf_lsm_h%ns)   )
-       ALLOCATE( surf_lsm_h%vegetation_type_name(1:surf_lsm_h%ns) )
-       ALLOCATE( surf_lsm_h%water_type_name(1:surf_lsm_h%ns)      )
-
-       surf_lsm_h%pavement_type_name   = 'none'
-       surf_lsm_h%vegetation_type_name = 'none'
-       surf_lsm_h%water_type_name      = 'none'
-
+       DO  l = 0, 1
+          ALLOCATE( surf_lsm_h(l)%pavement_type(1:surf_lsm_h(l)%ns)   )
+          ALLOCATE( surf_lsm_h(l)%vegetation_type(1:surf_lsm_h(l)%ns) )
+          ALLOCATE( surf_lsm_h(l)%water_type(1:surf_lsm_h(l)%ns)      )
+
+          surf_lsm_h(l)%pavement_type   = 0
+          surf_lsm_h(l)%vegetation_type = 0
+          surf_lsm_h(l)%water_type      = 0
+
+          ALLOCATE( surf_lsm_h(l)%pavement_type_name(1:surf_lsm_h(l)%ns)   )
+          ALLOCATE( surf_lsm_h(l)%vegetation_type_name(1:surf_lsm_h(l)%ns) )
+          ALLOCATE( surf_lsm_h(l)%water_type_name(1:surf_lsm_h(l)%ns)      )
+
+          surf_lsm_h(l)%pavement_type_name   = 'none'
+          surf_lsm_h(l)%vegetation_type_name = 'none'
+          surf_lsm_h(l)%water_type_name      = 'none'
+       ENDDO
        DO  l = 0, 3
           ALLOCATE( surf_lsm_v(l)%pavement_type(1:surf_lsm_v(l)%ns)   )
@@ -2635,7 +2687,8 @@
 
           CASE ( 'vegetation' )
-
-             surf_lsm_h%vegetation_surface = .TRUE.
-             surf_lsm_h%frac(:,ind_veg_wall) = 1.0_wp
+             DO  l = 0, 1
+                surf_lsm_h(l)%vegetation_surface = .TRUE.
+                surf_lsm_h(l)%frac(:,ind_veg_wall) = 1.0_wp
+             ENDDO
              DO  l = 0, 3
                 surf_lsm_v(l)%vegetation_surface = .TRUE.
@@ -2644,9 +2697,10 @@
 
           CASE ( 'water' )
-
-             surf_lsm_h%water_surface = .TRUE.
-             surf_lsm_h%frac(:,ind_wat_win) = 1.0_wp
-!
-!--          Note, vertical water surface does not really make sense.
+!
+!--          Note, downward and vertical water surface does not really make sense.
+             DO  l = 0, 1
+               surf_lsm_h(l)%water_surface = .TRUE.
+               surf_lsm_h(l)%frac(:,ind_wat_win) = 1.0_wp
+             ENDDO
              DO  l = 0, 3
                 surf_lsm_v(l)%water_surface   = .TRUE.
@@ -2655,7 +2709,8 @@
 
           CASE ( 'pavement' )
-
-             surf_lsm_h%pavement_surface = .TRUE.
-                surf_lsm_h%frac(:,ind_pav_green) = 1.0_wp
+             DO  l = 0, 1
+                surf_lsm_h(l)%pavement_surface = .TRUE.
+                surf_lsm_h(l)%frac(:,ind_pav_green) = 1.0_wp
+             ENDDO
              DO  l = 0, 3
                 surf_lsm_v(l)%pavement_surface   = .TRUE.
@@ -2664,27 +2719,27 @@
 
           CASE ( 'netcdf' )
-
-             DO  m = 1, surf_lsm_h%ns
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-                IF ( vegetation_type_f%var(j,i) /= vegetation_type_f%fill )    &
-                   surf_lsm_h%vegetation_surface(m) = .TRUE.
-                IF ( pavement_type_f%var(j,i)   /= pavement_type_f%fill )      &
-                   surf_lsm_h%pavement_surface(m) = .TRUE.
-                IF ( water_type_f%var(j,i)      /= water_type_f%fill )         &
-                   surf_lsm_h%water_surface(m) = .TRUE.
-!
-!--             Check if at least one type is set.
-                IF ( .NOT. surf_lsm_h%vegetation_surface(m)  .AND.             &
-                     .NOT. surf_lsm_h%pavement_surface(m)    .AND.             &
-                     .NOT. surf_lsm_h%water_surface(m) )  THEN
-                   WRITE( message_string, * ) 'Horizontal surface element ' // &
-                                       ' at i, j = ',  i, j,                   &
-                                       ' is neither a vegetation, ' //         &
-                                       'pavement, nor a water surface.'
-                   CALL message( 'land_surface_model_mod', 'PA0619',          &
-                                  2, 2, myid, 6, 0 )
-                ENDIF
-
+             DO  l = 0, 1
+                DO  m = 1, surf_lsm_h(l)%ns
+                   i = surf_lsm_h(l)%i(m)
+                   j = surf_lsm_h(l)%j(m)
+                   IF ( vegetation_type_f%var(j,i) /= vegetation_type_f%fill )    &
+                      surf_lsm_h(l)%vegetation_surface(m) = .TRUE.
+                   IF ( pavement_type_f%var(j,i)   /= pavement_type_f%fill )      &
+                      surf_lsm_h(l)%pavement_surface(m) = .TRUE.
+                   IF ( water_type_f%var(j,i)      /= water_type_f%fill )         &
+                      surf_lsm_h(l)%water_surface(m) = .TRUE.
+   !
+   !--             Check if at least one type is set.
+                   IF ( .NOT. surf_lsm_h(l)%vegetation_surface(m)  .AND.             &
+                        .NOT. surf_lsm_h(l)%pavement_surface(m)    .AND.             &
+                        .NOT. surf_lsm_h(l)%water_surface(m) )  THEN
+                      WRITE( message_string, * ) 'Horizontal surface element ' // &
+                                          ' at i, j = ',  i, j,                   &
+                                          ' is neither a vegetation, ' //         &
+                                          'pavement, nor a water surface.'
+                      CALL message( 'land_surface_model_mod', 'PA0619',          &
+                                     2, 2, myid, 6, 0 )
+                   ENDIF
+                ENDDO
              ENDDO
 !
@@ -2790,46 +2845,47 @@
 !--    location (already checked).
        IF ( input_pids_static  .AND.  surface_fraction_f%from_file )  THEN
-          DO  m = 1, surf_lsm_h%ns
-             i = surf_lsm_h%i(m)
-             j = surf_lsm_h%j(m)
-!
-!--          0 - vegetation fraction, 1 - pavement fraction, 2 - water fraction
-             IF ( surface_fraction_f%frac(ind_veg_wall,j,i) /=                 &
-                  surface_fraction_f%fill )  THEN
-                surf_lsm_h%frac(m,ind_veg_wall)  =                             &
-                                    surface_fraction_f%frac(ind_veg_wall,j,i)
-             ENDIF
-             IF ( surface_fraction_f%frac(ind_pav_green,j,i) /=                &
-                  surface_fraction_f%fill )  THEN
-                surf_lsm_h%frac(m,ind_pav_green) =                             &
-                                    surface_fraction_f%frac(ind_pav_green,j,i)
-             ENDIF
-             IF ( surface_fraction_f%frac(ind_wat_win,j,i) /=                  &
-                  surface_fraction_f%fill )  THEN
-                surf_lsm_h%frac(m,ind_wat_win)   =                             &
-                                    surface_fraction_f%frac(ind_wat_win,j,i)
-             ENDIF
-!
-!--          Check if sum of relative fractions is zero. This case, give an
-!--          error message.
-             IF ( SUM ( surf_lsm_h%frac(m,:) ) == 0.0_wp )  THEN
-                WRITE( message_string, * )                                     &
-                                 'surface fractions at grid point (j,i) = (',  &
-                                 j, i, ') are all zero.'
-                CALL message( 'land_surface_model_mod', 'PA0688',              &
-                               2, 2, myid, 6, 0 )
-             ENDIF
-!
-!--          In case the sum of all surfaces is not 1, which may happen
-!--          due to rounding errors or type conversions, normalize the
-!--          fractions to one. Note, at the moment no tile approach is
-!--          implemented, so that relative fractions are either 1 or zero.
-             IF ( SUM ( surf_lsm_h%frac(m,:) ) > 1.0_wp  .OR.                  &
-                  SUM ( surf_lsm_h%frac(m,:) ) < 1.0_wp  )  THEN
-                surf_lsm_h%frac(m,:) = surf_lsm_h%frac(m,:) /                  &
-                                       SUM ( surf_lsm_h%frac(m,:) )
-
-             ENDIF
-
+          DO  l = 0, 1
+             DO  m = 1, surf_lsm_h(l)%ns
+                i = surf_lsm_h(l)%i(m)
+                j = surf_lsm_h(l)%j(m)
+   !
+   !--          0 - vegetation fraction, 1 - pavement fraction, 2 - water fraction
+                IF ( surface_fraction_f%frac(ind_veg_wall,j,i) /=                 &
+                     surface_fraction_f%fill )  THEN
+                   surf_lsm_h(l)%frac(m,ind_veg_wall)  =                             &
+                                       surface_fraction_f%frac(ind_veg_wall,j,i)
+                ENDIF
+                IF ( surface_fraction_f%frac(ind_pav_green,j,i) /=                &
+                     surface_fraction_f%fill )  THEN
+                   surf_lsm_h(l)%frac(m,ind_pav_green) =                             &
+                                       surface_fraction_f%frac(ind_pav_green,j,i)
+                ENDIF
+                IF ( surface_fraction_f%frac(ind_wat_win,j,i) /=                  &
+                     surface_fraction_f%fill )  THEN
+                   surf_lsm_h(l)%frac(m,ind_wat_win)   =                             &
+                                       surface_fraction_f%frac(ind_wat_win,j,i)
+                ENDIF
+   !
+   !--          Check if sum of relative fractions is zero. This case, give an
+   !--          error message.
+                IF ( SUM ( surf_lsm_h(l)%frac(m,:) ) == 0.0_wp )  THEN
+                   WRITE( message_string, * )                                     &
+                                    'surface fractions at grid point (j,i) = (',  &
+                                    j, i, ') are all zero.'
+                   CALL message( 'land_surface_model_mod', 'PA0688',              &
+                                  2, 2, myid, 6, 0 )
+                ENDIF
+   !
+   !--          In case the sum of all surfaces is not 1, which may happen
+   !--          due to rounding errors or type conversions, normalize the
+   !--          fractions to one. Note, at the moment no tile approach is
+   !--          implemented, so that relative fractions are either 1 or zero.
+                IF ( SUM ( surf_lsm_h(l)%frac(m,:) ) > 1.0_wp  .OR.                  &
+                     SUM ( surf_lsm_h(l)%frac(m,:) ) < 1.0_wp  )  THEN
+                   surf_lsm_h(l)%frac(m,:) = surf_lsm_h(l)%frac(m,:) /                  &
+                                          SUM ( surf_lsm_h(l)%frac(m,:) )
+
+                ENDIF
+             ENDDO
           ENDDO
           DO  l = 0, 3
@@ -2881,14 +2937,16 @@
        ELSEIF ( input_pids_static  .AND.  .NOT. surface_fraction_f%from_file ) &
        THEN
-          DO  m = 1, surf_lsm_h%ns
-             i = surf_lsm_h%i(m)
-             j = surf_lsm_h%j(m)
-
-             IF ( vegetation_type_f%var(j,i) /= vegetation_type_f%fill )       &
-                surf_lsm_h%frac(m,ind_veg_wall)  = 1.0_wp
-             IF ( pavement_type_f%var(j,i)   /= pavement_type_f%fill   )       &
-                surf_lsm_h%frac(m,ind_pav_green) = 1.0_wp
-             IF ( water_type_f%var(j,i)      /= water_type_f%fill      )       &
-                surf_lsm_h%frac(m,ind_wat_win)   = 1.0_wp
+          DO  l = 0, 1
+             DO  m = 1, surf_lsm_h(l)%ns
+                i = surf_lsm_h(l)%i(m)
+                j = surf_lsm_h(l)%j(m)
+
+                IF ( vegetation_type_f%var(j,i) /= vegetation_type_f%fill )       &
+                   surf_lsm_h(l)%frac(m,ind_veg_wall)  = 1.0_wp
+                IF ( pavement_type_f%var(j,i)   /= pavement_type_f%fill   )       &
+                   surf_lsm_h(l)%frac(m,ind_pav_green) = 1.0_wp
+                IF ( water_type_f%var(j,i)      /= water_type_f%fill      )       &
+                   surf_lsm_h(l)%frac(m,ind_wat_win)   = 1.0_wp
+             ENDDO
           ENDDO
           DO  l = 0, 3
